from Tkinter import *
import phm, time

Vref = 2500.00
range = 5000.000
offset = 2500.00
m = 5000.0 / 65535
c = -2500.0 

def set_dac():
    y = float(DAC.get())
    if y < 0 or y > 2500:
      msg.insert(END, 'DAC value from 0 to 2500 mV')
      return 
    dac = int( (y - c) / m)
    print y, dac   
    p.hr_set_dac(dac)
    ss = 'DAC set to %6.3f mV\n'%( m * dac + c)
    msg.insert(END,ss)
        
def select_chan():
    chan = int(Chan.get())
    p.hr_select_adc(chan)
    ss = 'Selected Channel %d\n'%chan
    msg.insert(END,ss)

def read_adc():
    res = p.hr_get_voltage()
    if len(res) == 1:		# Error return
        ss = res
    else:
        ss = 'ADC %6.3f mV\n'%res[1]
    msg.insert(END,ss)

def int_cal():
    chan = int(Chan.get())
    res = p.hr_internal_cal(chan)
    print res
    ss = 'Chan %d :Offset = %x Gain = %x\n'%(chan,res[0],res[1])
    msg.insert(END,ss)

def ext_zero():
    chan = int(Chan.get())
    res = p.hr_external_cal(chan,0)
    ss = 'Chan %d : Offset = %x Gain = %x\n'%(chan, res[0],res[1])
    msg.insert(END,ss)

def ext_fs():
    chan = int(Chan.get())
    res = p.hr_external_cal(chan,1)
    ss = 'chan %d : Offset = %x Gain = %x\n'%(chan,res[0],res[1])
    msg.insert(END,ss)

def clear():
    msg.delete(1.0,END)


p = phm.phm()
root = Tk()
f = Frame(root)
f.pack()

l = Label(f,text ='DAC = ')
l.pack(side=LEFT)
DAC = StringVar()
t=Entry(f, width=6, bg = 'white', textvariable = DAC)
t.pack(side=LEFT, anchor = S)
DAC.set('0')

b4 = Button(f,text = 'SET DAC',command = set_dac)
b4.pack(side=LEFT)

l = Label(f,text ='CHAN = ')
l.pack(side=LEFT)
Chan = StringVar()
t=Entry(f, width=6, bg = 'white', textvariable = Chan)
t.pack(side=LEFT, anchor = S)
Chan.set('1')
b0 = Button(f,text = 'Set Chan',command = select_chan)
b0.pack(side=LEFT)

b1 = Button(f,text = 'Read',command = read_adc)
b1.pack(side=LEFT)
b2 = Button(f,text = 'INT CAL',command = int_cal)
b2.pack(side=LEFT)
b4 = Button(f,text = 'EXT 0',command = ext_zero)
b4.pack(side=LEFT)
b4 = Button(f,text = 'EXT FS',command = ext_fs)
b4.pack(side=LEFT)
b4 = Button(f,text = 'CLRTEXT',command = clear)
b4.pack(side=LEFT)

msgframe = Frame(root)
msgframe.pack(side=TOP,fill=BOTH)
scrollbar = Scrollbar(msgframe)
scrollbar.pack(side=RIGHT, fill=Y)
msg = Text(msgframe, width = 100, height = 20,\
      fg = 'black', bg = 'white', spacing2 = 10,\
      wrap=WORD, yscrollcommand=scrollbar.set)
msg.pack(side = TOP, fill = BOTH, expand = 1)
scrollbar.config(command=msg.yview)

root.mainloop()
