import phm, math, time
p=phm.phm()

"""
At ice point v = 3113.4 
At LN2 v = 591.4
At body v = 3504.4
Boiling water  4301 mV
"""
slope = 0.0795
intercept = 28.93

gain = 1 + 10000.0/330.0# measured amplifier gain
offset = 0.0		# Amplifier offset, measured with input grounded
ccs_current = 1.0	# CCS gave 982 mV across a 998 Ohm resistor


def	bval2temp(val):
        global slope, intecept
        volt = val * 5000.0 / 1023.0
        return slope * volt + intercept


def r2t(r):	# Convert resistance to temperature for PT100
	r0 = 100.0
	A = 3.9083e-3
	B = -5.7750e-7
	c = 1 - r/r0
	b4ac = math.sqrt( A*A - 4 * B * c)
	t = (-A + b4ac) / (2.0 * B)
	return t

def v2r(val):
#        print val
        volt = val * 5000.0 / 1023.0
#        print volt
	volt = (volt - offset)/gain
	return volt / ccs_current

x = 0
while p.pmrb_running():
  time.sleep(1)
  print 'waiting for pmrb ',x
  x = x+1

v= p.pmrb_get_data() 
#print v[1]
#print v[0]



for item in v[0]:
        s = str(item[0])
        i = 1
        while i < len(item):
    	  r = v2r(item[i])
#    	  s = s + ' %5.1f ' %(r2t(r)+273)
#    	  s = s + ' %5.1f ' %(bval2temp(item[1]))
          volt = item[1] * 5000.0 / 1023.0
    	  s = s + ' %5.1f ' %(volt)
    	  i = i + 1
        print s

