import phm, time
from Tkinter import *
              
data = []
voltage = 0.0

def sample():
    global fd, data, voltage
    fd.set_voltage(voltage)
    time.sleep(0.001)
    vdiode  = fd.zero_to_5000()[1]
    i = (voltage - vdiode) / 1000.0		# Ohm's law
    mv = (vdiode, i)
    data.append(mv)
#    print mv
    if len(data) > 1:
        fd.line(data)

    voltage = voltage + (5000.0/255.)
    if voltage <= Vmax.get():
        root.after(5, sample)
  
def start():
  global fd, data, root, voltage
  voltage = 0
  data = []
  fd.remove_lines()
  vmax = Vmax.get()
  b = float(vmax) / 1000.0		# maximum possible current
  fd.set_scale(0, 0, vmax,b)
  root.after(1, sample)

def save():
  global data,fd
  fd.save_data(data,'iv.dat')

def analyze():
  try:
      import pygrace
  except:
      return
  global data
  pg = pygrace.grace()
  x = []
  y = []
  for xy in data:
    x.append(xy[0])
    y.append(xy[1])
  pg.plot(x,y)
  
fd = phm.phm()
fd.set_adc_size(2)
fd.stop_wave()
root = Tk()
fd.window(400,300,root)

cmd = Frame(root)
cmd.pack(side=BOTTOM, anchor = SW)

Vmax = Scale(cmd, label = 'Vmax (mV)', from_ = 1000, to = 5000, length=100,\
resolution = 500, orient = HORIZONTAL)
Vmax.pack(side=LEFT)

b = Button(cmd,text='Start', command = start)
b.pack(side=LEFT, anchor = S)

b=Button(cmd,text='Save', command = save)
b.pack(side=LEFT, anchor = S)

b=Button(cmd,text='Analyse', command = analyze)
b.pack(side=LEFT, anchor = S)

fd.set_scale(0,0,Vmax.get(),5)
root.mainloop()
