import phm, time, math
from Tkinter import *
              
delay = 50
npoints = 200

"""
At ice point v = 3113.4 
At LN2 v = 591.4
At body v = 3504.4
Boiling water  4301 mV

slope = 0.0795
intercept = 28.93

def	bval2temp(val):
        global slope, intecept
        volt = val * 5000.0 / 1023.0
        return slope * volt + intercept
"""

gain = 1 + 10000.0/330.0# measured amplifier gain
offset = 0.0		# Amplifier offset, measured with input grounded
ccs_current = 1.0	# CCS gave 982 mV across a 998 Ohm resistor

def	bval2temp(val):
        global slope, intecept
        volt = val * 5000.0 / 1023.0
        return slope * volt + intercept

def r2t(r):	# Convert resistance to temperature for PT100
	r0 = 100.0
	A = 3.9083e-3
	B = -5.7750e-7
	c = 1 - r/r0
	b4ac = math.sqrt( A*A - 4 * B * c)
	t = (-A + b4ac) / (2.0 * B)
	return t

def v2r(val):
        volt = val * 5000.0 / 1023.0
	volt = (volt - offset)/gain
	return volt / ccs_current

def charge():
    global data
    v= p.pmrb_get_data()
    data = []
    for x in v[0]:
  	  r = v2r(x[1])
    	  temp = r2t(r) + 273 + 6
    	  data.append((x[0], temp))
    print v[1]
    p.set_scale(0,0,1000,300)
    p.plot(data)
    
def save():
  global p, data
  p.save_data(data,'gbabu.dat')

def analyze():
  try:
      import pygrace
  except:
      return
  global data
  pg = pygrace.grace()
  x = []
  y = []
  for xy in data:
    x.append(xy[0])
    y.append(xy[1])
  pg.plot(x,y)
  
p = phm.phm()
p.select_adc(0)
p.set_adc_size(2)
data = p.read_block(2,10,0)	#dummy read
root = Tk()
p.plot(data,400,300,root)

f=Frame(root)
f.pack(side=BOTTOM, anchor = SW)

"""
Npoints = Scale(f, label = 'Npoints', from_ = 100, to=400, resolution = 100,\
length=80,orient = HORIZONTAL)
Npoints.pack(side=LEFT, anchor = SW)
Delay = Scale(f, label = 'Delay', from_ = 20, to = 200, length=100,\
resolution = 20, orient = HORIZONTAL)
Delay.pack(side=LEFT)
"""

b=Button(f,text='Read PROM', command = charge)
b.pack(side=LEFT, anchor = S)

b=Button(f,text='Save', command = save)
b.pack(side=LEFT, anchor = S)

b=Button(f,text='Analyse', command = analyze)
b.pack(side=LEFT, anchor = S)

b.pack()

root.title('SEEPROM Plugin Based Data Collection')
root.mainloop()

