from BaseHTTPServer import HTTPServer
from BaseHTTPServer import BaseHTTPRequestHandler
import phm, string, time

import matplotlib
matplotlib.use('Agg')  # force the antigrain backend
from matplotlib import rc
from matplotlib.backends.backend_agg import FigureCanvasAgg
from matplotlib.figure import Figure

def do_expt(action):
    p = phm.phm()
    p.select_adc(0)
    p.set_adc_size(2)
    if action == 'Charge':
      p.write_outputs(0)
      p.enable_set_high(3)
    else:
      p.write_outputs(8)
      p.enable_set_low(3)
    time.sleep(1)
    v=p.read_block(200,20,0)
    if v == None:
      return False
    x = []
    y = []
    for k in v:
      x.append(k[0]*0.001)
      y.append(k[1]*0.001)

    fig = Figure()	# Use matplotlib to make the .png file
    ax = fig.add_axes([0.2, 0.3, 0.7, 0.6])
    ax.plot(x,y)
    ax.set_xlabel('Time (ms)')
    ax.set_ylabel('Voltage (V)')
    canvas = FigureCanvasAgg(fig)
    canvas.print_figure('cap.png', dpi=100)
    print 'Saved picture'
    return True
    
class myRequestHandler(BaseHTTPRequestHandler):
  def do_GET(self):
    try:
      print self.path
      if self.path != '/':
          self.send_response(200)
          print 'request for CAP.PNG'
          if self.path == '/cap.png':
            print 'request for CAP.PNG'
            self.send_header("Content-type", "image/png")
          else:
            self.send_header("Content-type", "text/plain")
          self.end_headers()
          f = open('.' + '/' + self.path)
          print 'sending CAP.PNG'
          self.wfile.write(f.read())
          print 'Sent picture'
          f.close()
          return
      else:
          self.send_response(200)
          self.end_headers()
          self.wfile.write('<html><body><center>'+\
            '<h4>Web Based Capacitor Charging/Discharging Experiment</h4>'+\
            '</center>'+\
            '<form method="post"> '+\
            '<input type="radio" name="action" value="Charge"> Charge <br>'+\
            '<input type="radio" name="action" value="Discharge"> Discharge<br> '+\
            '<input type="submit" value="Measure">'+\
            '</form>')
          self.wfile.write('</body></html>')
          print 'Done First Page'
    except:
      self.wfile.write("Server Not Responding")

  def do_POST(self):
    if self.headers.dict.has_key("content-length"):
       content_length = string.atoi(self.headers.dict["content-length"])
       raw_post_data = self.rfile.read(content_length)
       action = raw_post_data.split('=')[1]
       self.send_response(200)
       try:
         if do_expt(action) == False:
           self.send_header("Content-type", "text/html")
           self.end_headers()
           self.wfile.write("<html><body>")
           self.wfile.write('Error')
           self.wfile.write("</html></body></html>")
         else:
           self.send_header("Content-type", "text/html")
           self.end_headers()
           self.wfile.write("<html><body>")
           self.wfile.write('Result of the Experiment is shown below<br>'+\
           '<img alt="cap.png" src="cap.png">')
           self.wfile.write("</html></body></html>")
           print 'Done Expt'
           """
           self.send_header("Content-type", "image/png")
           self.end_headers()
           f = open('cap.png')
           self.wfile.write(f.read())
           f.close()
           """
       except:
           print 'Error'
           self.send_header("Content-type", "text/html")
           self.end_headers()
           self.wfile.write("<html><body>")
           self.wfile.write('Experimental Setup Not Responding')
           self.wfile.write("</html></body></html>")
  
  def printCustomHTTPResponse(self, respcode):
    self.send_response(respcode)
    self.send_header("Content-type", "text/html")
    self.end_headers()
    
#-------------------------------main---------------------------    
p = phm.phm()
myServer = HTTPServer(('', 80), myRequestHandler)
while 1:
  myServer.handle_request()
